//************************************************************************
//
//	HTTPSFunctions.m
//
//	by Jrgen Mllenhoff <jumo@oic.de>		
//
//
//	This code is supplied "as is" the author makes no warranty as to its 
//	suitability for any purpose.  This code is free and may be distributed 
//	in accordance with the terms of the:
//		
//			GNU GENERAL PUBLIC LICENSE
//			Version 2, June 1991
//			copyright (C) 1989, 1991 Free Software Foundation, Inc.
// 			675 Mass Ave, Cambridge, MA 02139, USA
//
//************************************************************************

#import	"HTTPSFunctions.h"

#import	<foundation/foundation.h>

#import <OmniWeb/OmniConsoleController.h>

#import <stdio.h>	// I need this for the ssl include
#import <ssl.h>
#import <err.h>

#import	"HTTPSUtilities.h"

RCS_ID("$Header: /LocalDeveloper/CVS/HTTPSExtension/HTTPSFunctions.m,v 1.3 1999/04/28 01:56:24 jurgen Exp $")

NSString *sslErrorString(void)
{
	BIO 		*memBio;
	char		*buffer;
	long		length;
	NSString	*tempString;

	memBio = BIO_new(BIO_s_mem());
	ERR_print_errors(memBio);
	if ((length = BIO_ctrl(memBio, BIO_CTRL_INFO, 0, (char *)&buffer)) > 0)
		tempString = [NSString stringWithCString:buffer length:length];
	else
		tempString = @"";
	BIO_free(memBio);

	return tempString;
}

void OmniConsoleLog(NSString *format, ...)
{
	va_list		argList;
	NSString	*logString;
	static		OmniConsoleController	*controller = nil;
	
	if (controller == nil)
	{
		if ([OmniConsoleController respondsToSelector:@selector(sharedInstance)])
		{
			controller = [OmniConsoleController sharedInstance];
		}
		else
		{
		SEL	theSelector;
		
			theSelector = NSSelectorFromString(@"sharedConsoleController");
			if ((theSelector != NULL) && [OmniConsoleController respondsToSelector:theSelector])
				controller = [OmniConsoleController perform:theSelector];
		}
	}
	
	va_start(argList, format);
	
	logString = [[NSString alloc] initWithFormat:format arguments:argList];
	[controller logTimestampedString:logString];
	[logString release];
}
